Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2643)
@@ -33,5 +33,11 @@
    !* IO manager *
    USE in_out_manager    
-                          
+ 
+   !* MPP library                         
+   USE lib_mpp 
+
+   !* Fortran utilities                         
+   USE lib_fortran
+
    !* physical constants *
    USE phycst            
@@ -88,4 +94,5 @@
    USE dom_oce , ONLY :   e1t        =>   e1t        !: horizontal scale factors at t-point (m)  
    USE dom_oce , ONLY :   e2t        =>   e2t        !: horizontal scale factors at t-point (m)   
+   USE dom_oce , ONLY :   e1e2t      =>   e1e2t      !: cell surface at t-point (m2)
    USE dom_oce , ONLY :   e1u        =>   e1u        !: horizontal scale factors at u-point (m)
    USE dom_oce , ONLY :   e2u        =>   e2u        !: horizontal scale factors at u-point (m)
@@ -194,5 +201,4 @@
 
 #endif
-   USE lib_mpp , ONLY :   lk_mpp    =>  lk_mpp        !: Mpp flag
 
    USE dom_oce , ONLY :   nn_cla    =>  nn_cla        !: flag (0/1) for cross land advection 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 2643)
@@ -17,6 +17,4 @@
    USE par_trc          ! TOP parameters
    USE oce_trc          ! ocean space and time domain variables
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! distributed memory computing
 
    IMPLICIT NONE
@@ -78,5 +76,5 @@
       !!----------------------------------------------------------------------
 
-      IF(wrk_in_use(3, 1,2))THEN
+      IF( wrk_in_use(3, 1,2) ) THEN
          CALL ctl_stop('prt_ctl_trc : requested workspace arrays unavailable.')
          RETURN
@@ -158,7 +156,5 @@
       END DO
       !
-      IF(wrk_not_released(3, 1,2))THEN
-         CALL ctl_stop('prt_ctl_trc : failed to release workspace arrays.')
-      END IF
+      IF( wrk_not_released(3, 1,2) ) CALL ctl_stop('prt_ctl_trc : failed to release workspace arrays.')
       !
    END SUBROUTINE prt_ctl_trc
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2643)
@@ -119,5 +119,4 @@
                trb(jpi,jpj,jpk,jptra),                             &
                gtru(jpi,jpj,jptra), gtrv(jpi,jpj,jptra),           &
-               rdttrc(jpk),                                        &
 # if defined key_diatrc && ! defined key_iomput
                trc2d(jpi,jpj,jpdia2d), trc3d(jpi,jpj,jpk,jpdia3d), &
@@ -125,11 +124,11 @@
 # if defined key_diabio
                trbio(jpi,jpj,jpk,jpdiabio),                        &
-# endif
-               STAT=trc_alloc)
+#endif
+               rdttrc(jpk),  STAT=trc_alloc )      
 
       IF( trc_alloc /= 0 )   CALL ctl_warn('trc_alloc: failed to allocate arrays')
       !
    END FUNCTION trc_alloc
-   
+
 #else
    !!----------------------------------------------------------------------
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 2643)
@@ -25,6 +25,4 @@
    USE par_trc
    USE dianam    ! build name of file (routine)
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp
    USE ioipsl
 
@@ -63,19 +61,4 @@
 CONTAINS
 
-   FUNCTION trc_dia_alloc()
-      !!---------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_dia_alloc  ***
-      !!---------------------------------------------------------------------
-      INTEGER :: trc_dia_alloc
-      !!---------------------------------------------------------------------
-
-      ALLOCATE(ndext50(jpij*jpk), ndext51(jpij), Stat=trc_dia_alloc)
-
-      IF(trc_dia_alloc /= 0)THEN
-         CALL ctl_warn('trc_dia_alloc : failed to allocate arrays.')
-      END IF
-
-   END FUNCTION trc_dia_alloc
-
 
    SUBROUTINE trc_dia( kt )  
@@ -200,7 +183,7 @@
          DO jn = 1, jptra
             IF( lutsav(jn) ) THEN
-               cltra  = ctrcnm(jn)   ! short title for tracer
-               cltral = ctrcnl(jn)   ! long title for tracer
-               cltrau = ctrcun(jn)   ! UNIT for tracer
+               cltra  = TRIM( ctrcnm(jn) )   ! short title for tracer
+               cltral = TRIM( ctrcnl(jn) )   ! long title for tracer
+               cltrau = TRIM( ctrcun(jn) )   ! UNIT for tracer
                CALL histdef( nit5, cltra, cltral, cltrau, jpi, jpj, nhorit5,  &
                   &          ipk, 1, ipk,  ndepit5, 32, clop, zsto, zout ) 
@@ -225,5 +208,5 @@
 
       DO jn = 1, jptra
-         cltra = ctrcnm(jn)      ! short title for tracer
+         cltra  = TRIM( ctrcnm(jn) )   ! short title for tracer
          IF( lutsav(jn) ) CALL histwrite( nit5, cltra, it, trn(:,:,:,jn), ndimt50, ndext50 )
       END DO
@@ -325,7 +308,7 @@
          ! more 3D horizontal arrays
          DO jl = 1, jpdia3d
-            cltra  = ctrc3d(jl)   ! short title for 3D diagnostic
-            cltral = ctrc3l(jl)   ! long title for 3D diagnostic
-            cltrau = ctrc3u(jl)   ! UNIT for 3D diagnostic
+            cltra  = TRIM( ctrc3d(jl) )   ! short title for 3D diagnostic
+            cltral = TRIM( ctrc3l(jl) )  ! long title for 3D diagnostic
+            cltrau = TRIM( ctrc3u(jl) )  ! UNIT for 3D diagnostic
             CALL histdef( nitd, cltra, cltral, cltrau, jpi, jpj, nhoritd,   &
                &          ipk, 1, ipk,  ndepitd, 32, clop, zsto, zout )
@@ -334,7 +317,7 @@
          ! more 2D horizontal arrays
          DO jl = 1, jpdia2d
-            cltra  = ctrc2d(jl)    ! short title for 2D diagnostic
-            cltral = ctrc2l(jl)   ! long title for 2D diagnostic
-            cltrau = ctrc2u(jl)   ! UNIT for 2D diagnostic
+            cltra  = TRIM( ctrc2d(jl) )   ! short title for 2D diagnostic
+            cltral = TRIM( ctrc2l(jl) )  ! long title for 2D diagnostic
+            cltrau = TRIM( ctrc2u(jl) )  ! UNIT for 2D diagnostic
             CALL histdef( nitd, cltra, cltral, cltrau, jpi, jpj, nhoritd,  &
                &          1, 1, 1,  -99, 32, clop, zsto, zout )
@@ -362,5 +345,5 @@
       ! more 3D horizontal arrays
       DO jl = 1, jpdia3d
-         cltra = ctrc3d(jl)   ! short title for 3D diagnostic
+         cltra  = TRIM( ctrc3d(jl) )   ! short title for 3D diagnostic
          CALL histwrite( nitd, cltra, it, trc3d(:,:,:,jl), ndimt50 ,ndext50)
       END DO
@@ -368,5 +351,5 @@
       ! more 2D horizontal arrays
       DO jl = 1, jpdia2d
-         cltra = ctrc2d(jl)   ! short title for 2D diagnostic
+         cltra  = TRIM( ctrc2d(jl) )   ! short title for 2D diagnostic
          CALL histwrite(nitd, cltra, it, trc2d(:,:,jl), ndimt51  ,ndext51)
       END DO
@@ -468,7 +451,7 @@
          ! biological trends
          DO jl = 1, jpdiabio
-            cltra  = ctrbio(jl)   ! short title for biological diagnostic
-            cltral = ctrbil(jl)   ! long title for biological diagnostic
-            cltrau = ctrbiu(jl)   ! UNIT for biological diagnostic
+            cltra  = TRIM( ctrbio(jl) )   ! short title for biological diagnostic
+            cltral = TRIM( ctrbil(jl) )  ! long title for biological diagnostic
+            cltrau = TRIM( ctrbiu(jl) )  ! UNIT for biological diagnostic
             CALL histdef( nitb, cltra, cltral, cltrau, jpi, jpj, nhoritb,  &
                &         ipk, 1, ipk,  ndepitb, 32, clop, zsto, zout)
@@ -494,5 +477,5 @@
 
       DO jl = 1, jpdiabio
-         cltra = ctrbio(jl)  ! short title for biological diagnostic
+         cltra  = TRIM( ctrbio(jl) )   ! short title for biological diagnostic
          CALL histwrite(nitb, cltra, it, trbio(:,:,:,jl), ndimt50,ndext50)
       END DO
@@ -513,4 +496,14 @@
 # endif 
 
+   INTEGER FUNCTION trc_dia_alloc()
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_dia_alloc  ***
+      !!---------------------------------------------------------------------
+
+      ALLOCATE( ndext50(jpij*jpk), ndext51(jpij), STAT=trc_dia_alloc )
+
+      IF( trc_dia_alloc /= 0 ) CALL ctl_warn('trc_dia_alloc : failed to allocate arrays.')
+
+   END FUNCTION trc_dia_alloc
 #else
    !!----------------------------------------------------------------------
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcdta.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 2643)
@@ -42,24 +42,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
-   FUNCTION trc_dta_alloc()
-      !!----------------------------------------------------------------------
-      !!                   ***  ROUTINE trc_dta_alloc  ***
-      !!----------------------------------------------------------------------
-      INTEGER :: trc_dta_alloc
-      !!----------------------------------------------------------------------
-
-      ALLOCATE(trdta(jpi,jpj,jpk,jptra),                   &
-               tracdta(jpi,jpj,jpk,jptra,2),               &
-               nlectr(jptra), ntrc1(jptra), ntrc2,(jptra), & 
-               !
-               Stat = trc_dta_alloc)
-
-      IF(trc_dta_alloc /= 0)THEN
-         CALL ctl_warn('trc_dta_alloc : failed to allocate arrays.')
-      END IF
-
-   END FUNCTION trc_dta_alloc
-
 
    SUBROUTINE trc_dta( kt )
@@ -219,4 +199,19 @@
    END SUBROUTINE trc_dta
 
+   INTEGER FUNCTION trc_dta_alloc()
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE trc_dta_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE(trdta(jpi,jpj,jpk,jptra),                   &
+               tracdta(jpi,jpj,jpk,jptra,2),               &
+               nlectr(jptra), ntrc1(jptra), ntrc2,(jptra), & 
+               !
+               STAT=trc_dta_alloc)
+
+      IF( trc_dta_alloc /= 0 ) CALL ctl_warn('trc_dta_alloc : failed to allocate arrays.')
+
+   END FUNCTION trc_dta_alloc
+
 #else
    !!----------------------------------------------------------------------
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2643)
@@ -28,8 +28,5 @@
    USE daymod
    USE zpshde          ! partial step: hor. derivative   (zps_hde routine)
-   USE in_out_manager  ! I/O manager
    USE prtctl_trc      ! Print control passive tracers (prt_ctl_trc_init routine)
-   USE lib_mpp         ! distributed memory computing library
-   USE lib_fortran     ! 
    
    IMPLICIT NONE
@@ -67,4 +64,5 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~'
 
+
       CALL top_alloc()              ! allocate TOP arrays
 
@@ -201,13 +199,4 @@
       USE trdmld_trc    , ONLY:   trd_mld_trc_alloc
 #endif
-#if defined key_cfc
-     USE trcsms_cfc     , ONLY:   trc_sms_cfc_alloc
-#endif
-#if defined key_c14b
-     USE trcsms_c14b    , ONLY:   trc_sms_c14b_alloc
-#endif
-#if defined key_lobster
-      USE sms_lobster   , ONLY:   sms_lobster_alloc      ! LOBSTER-related alloc routines...
-#endif
       !
       INTEGER :: ierr
@@ -231,14 +220,4 @@
       ierr = ierr + trd_mld_trc_alloc()
 #endif
-#if defined key_cfc
-      ierr = ierr + trc_sms_cfc_alloc()
-#endif
-#if defined key_c14b
-      ierr = ierr + trc_sms_c14b_alloc()
-#endif
-      !
-#if defined key_lobster
-      ierr = ierr + sms_lobster_alloc()      ! Start of LOBSTER-related alloc routines
-#endif
       !
       IF( lk_mpp    )   CALL mpp_sum( ierr )
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2643)
@@ -26,6 +26,4 @@
    USE trcnam_c14b       ! C14 SMS namelist
    USE trcnam_my_trc     ! MY_TRC SMS namelist
-   USE in_out_manager    ! I/O manager
-   USE lib_mpp           ! MPP library
    USE trdmod_trc_oce
 
@@ -104,9 +102,9 @@
 
       DO jn = 1, jptra
-         ctrcnm(jn) = sn_tracer(jn)%clsname
-         ctrcnl(jn) = sn_tracer(jn)%cllname
-         ctrcun(jn) = sn_tracer(jn)%clunit
-         lutini(jn) = sn_tracer(jn)%llinit
-         lutsav(jn) = sn_tracer(jn)%llsave
+         ctrcnm(jn) = TRIM( sn_tracer(jn)%clsname )
+         ctrcnl(jn) = TRIM( sn_tracer(jn)%cllname )
+         ctrcun(jn) = TRIM( sn_tracer(jn)%clunit  )
+         lutini(jn) =       sn_tracer(jn)%llinit 
+         lutsav(jn) =       sn_tracer(jn)%llsave
       END DO
 
@@ -122,7 +120,7 @@
          DO jn = 1, jptra
             WRITE(numout,*) '   tracer nb             : ', jn 
-            WRITE(numout,*) '   short name            : ', TRIM(ctrcnm(jn))
-            WRITE(numout,*) '   long name             : ', TRIM(ctrcnl(jn))
-            WRITE(numout,*) '   unit                  : ', TRIM(ctrcun(jn))
+            WRITE(numout,*) '   short name            : ', ctrcnm(jn)
+            WRITE(numout,*) '   long name             : ', ctrcnl(jn)
+            WRITE(numout,*) '   unit                  : ', ctrcun(jn)
             WRITE(numout,*) '   initial value in FILE : ', lutini(jn) 
             WRITE(numout,*) ' '
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2643)
@@ -26,6 +26,4 @@
    USE trc
    USE trcnam_trp
-   USE lib_mpp
-   USE lib_fortran
    USE iom
    USE trcrst_cfc      ! CFC      
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcstp.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 2643)
@@ -64,5 +64,5 @@
          ELSE                  ;   CALL trc_dia( kt )
          ENDIF
-                                   CALL trc_sms( kt )           ! tracers: sink and source
+      !                             CALL trc_sms( kt )           ! tracers: sink and source
                                    CALL trc_trp( kt )           ! transport of passive tracers
          IF( kt == nit000 )     CALL iom_close( numrtr )     ! close input  passive tracers restart file
